import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class gallinaOus extends PApplet {

//variables 
int midaOuX = 20;
int midaOuY = 27;
int posicioOuX = PApplet.parseInt(random(500));
int posicioOuY = midaOuY/2;
int velocitatOu = 3;
int posicioXP1 = 450;
int posicioXP2 = 400;
int posicioYP1 = 380;
int posicioYP2 = 450;
int marcador = 0;
int videsP1 = 5;
int videsP2 = 3;
PImage backg, ou, player1, player2, anec, gameOverImg, gameWinImg;
int pausa = 20;
boolean ouTrencat = false;
boolean gameOver = false;
int colGir=0;

public void setup() {
   
   backg = loadImage ("farm1.jpg");
   ou = loadImage ("egg.png");
   player1 = loadImage ("farmerLeft.png");
   gameOverImg = loadImage("gameOver.png");
   gameWinImg = loadImage("alpha.png");
}

public void draw() {
  background(0, 0, 0);
  image (backg, 0, 0);
  fill (255,255,255);
//gestió de nivells per acabar :)
  int nivell = PApplet.parseInt(marcador/5);
//Descomenteu per veure les colisions de l'ou amb el cistell
//rect (posicioXP1+30+colGir,posicioYP1,10,120);
//rect (posicioXP1+10+colGir,posicioYP1,10,120);
//Marcador
  textSize(30);
  text ("Punts: "+marcador, 20, 30);
  text ("Vides: "+videsP1, 22, 60);
//posicionament del player1 "farmer"  
  image (player1, posicioXP1, posicioYP1, 100, 120);
//Si el joc es dona per finalitzat  
  if(gameOver==true){
    background(0, 0, 0);
    image (gameOverImg, 40, 120);
    image (gameWinImg, 0, 0);
  }
//he ideat aixó per poder para l'ou sense para el joc senser  
  if(pausa==20){
    //El joc no ha acabat per tant l'ou ha de seguir baixant
    if(gameOver==false){
      gestioNivells();
      posicioOuY+=velocitatOu;
    }
  }
//colisio de l'ou amb ek cistell  
  if((posicioXP1+30+colGir>=posicioOuX)&&(posicioOuX>=posicioXP1+10+colGir)&&(posicioOuY-40>=posicioYP1)&&(posicioOuY<=posicioYP1+80)){
    tiraOu(ouTrencat=false);
  }
//colisio terra  
  if (posicioOuY>posicioYP1+80) {
    tiraOu(ouTrencat=true);
  }
//primer ou  
  image (ou, posicioOuX, posicioOuY, midaOuX, midaOuY);
}
//escolta de les tecles preparat per 2 jugadors (igual hi ha una manera millor?¿?¿??)
public void keyPressed() {
  switch(keyCode) {
  case RIGHT:
    println(posicioXP1);
    if(posicioXP1<width-20){
      posicioXP1+=15;
      player1 = loadImage ("farmerRight.png");
      colGir=45;
    }
    break;
  case LEFT:
    println(posicioXP1);
    if(posicioXP1>-10) {
      posicioXP1-=10;
      player1 = loadImage ("farmerLeft.png");
      colGir=0;
    }
    break;
  }
  switch(key) {
  case 'w':
    println("upP2");
    break;
  case 's':
    println("downP2");
    break;
  case 'd':
    println("rightP2");
    break;
  case 'a':
    println("leftP2");
    break;
  }
}
//funcion que gestiona els ous :)
public void tiraOu(boolean ouTrencat){
  if(ouTrencat==true) {
    ou = loadImage ("eggBreak.png");
  }
  //alló que us deia que m'he inventat suposo que es pot fer amb millis()
  pausa--;
  println(pausa);
  if(pausa==0){
    posicioOuX = PApplet.parseInt(random(500));
    posicioOuY = -32;
    ou = loadImage ("egg.png"); 
    pausa = 20;
    if((videsP1>0)&&(ouTrencat==true)) {
      videsP1-=1;
    } else {
      marcador++;
    }
    //preparat per el segon player
    if(videsP2>0) {
    }
    if(videsP1<=0){
     gameOver=true;
    }
  }
}

public void gestioNivells() {
  if(marcador<4){
    backg = loadImage ("farm1.jpg");
    ou = loadImage ("egg.png");
    velocitatOu = 2;
  }
  if((marcador>=4)&&(marcador<10)){
    backg = loadImage ("farm2.jpg");
    ou = loadImage ("egg.png");
    velocitatOu = 3;
  }
  if((marcador>=10)&&(marcador<20)){
    backg = loadImage ("farm3.jpg");
    ou = loadImage ("egg.png");
    velocitatOu = 4; 
  }
   if(marcador==20){
    gameOver=true;
    gameWinImg = loadImage ("win.jpg");
  }
}
/*Podeu descomentar i fer anar més ràpid l'ou amb la rodeta del mouse
void mouseWheel(MouseEvent event) {
   int incr = -int(event.getAmount());
   println(incr);
   if ((incr<1)&&(velocitatOu<=0)) {velocitatOu=0;}
   else  {velocitatOu+=incr;}
}
*/
  public void settings() {  size (500, 500); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "gallinaOus" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
